'**************************************
'
' C-Control/BASIC       TRMESS2.BAS
'
' Aufgabe:
'
' - Transistorpruefung, NPN und PNP
' - Messung der Stromverstaerkung
' - Arbeitspunkt: Ic=1mA, Uce=2,8V
'
'**************************************
' --- Definitionen --------------------

define A DA[1]
define E1 AD[1]
define E2 AD[2]
define E3 AD[3]
define U1 Byte
define V word

' --- Programmoperationen -------------



#Loop
A= 127       '2,5V
pause 10
if E2 < 50 then goto NPN else goto PNP
pause 50
goto Loop

#NPN
  U1=0: A=U1
  pause 10
#Loop2  
  U1=U1+1
  A = U1
  if E3 > 140 then goto loop2
  V= ((255-E3)*100) / (E1-E2)
  print "NPN", V, "-fach"
goto Loop              'Endlosschleife

#PNP
  U1=255: A=U1
  pause 10
#Loop3  
  U1=U1-1
  A = U1
  if E3 > 140 then goto loop3
  V= ((255-E3)*100) / (E2-E1)
  print "PNP", V, "-fach"
goto Loop              'Endlosschleife



end





