'**************************************
'
' C-Control/BASIC       BUS8255.BAS
'
' Aufgabe:
'
' - Universelles Bus-System
' - Ansteuerung von zwei 8255
'
'**************************************
' --- Definitionen --------------------

define Datenbus byteport[1]
define Adressbus byteport[2]
define WR port[15]
define RD port[16]
define Daten byte
define Adresse byte

' --- Programmoperationen -------------

WR = ON
RD = ON

'IC1:	56...59 1110XX
'IC2:  	52...55	1101XX
'IC3:	44...47	1011XX
'IC4:	28...31	0111XX

Adresse = 59        'IC1, Steuerregister
Daten = 128         'A, B, C Outputs
gosub Write

Adresse = 55        'IC2, Steuerregister
Daten = 155         'A, B, C Inputs
gosub Write

#Loop
  Adresse = 52      'IC2, Port A
  gosub Read        'lesen
  Adresse = 56      'IC1, Port A
  gosub Write       'schreiben
goto Loop           'Endlosschleife

#Write
  Datenbus = Daten
  Adressbus = Adresse OR 192 'RD=1, WR=1
  WR = OFF                   'WR-Impuls
  WR = ON
  deact Datenbus
  return

#READ
  Adressbus = Adresse OR 192 'RD=1, WR=1
  RD = OFF                   'RD-Impuls
  Daten = Datenbus           'lesen
  RD = ON
  return

end





