'**************************************
'
' C-Control/BASIC       INHC573.BAS
'
' Aufgabe:
'
' - Porterweiterung fr 32 Eingaenge
' - 74HC573-Adressierung ber P13...P16
'
'**************************************
' --- Definitionen --------------------

define Bus byteport[1]
define Latch1 port[13]
define Latch2 port[14]
define Latch3 port[15]
define Latch4 port[16]
define Adresse byte
define Daten byte

' --- Programmoperationen -------------

Latch1 = ON
Latch2 = ON
Latch3 = ON
Latch4 = ON
#Loop
  gosub In1
  print "Adresse 0: ", Daten
  gosub In2
  print "Adresse 1: ", Daten
  gosub In3
  print "Adresse 2: ", Daten
  gosub In4
  print "Adresse 3: ", Daten
  pause 50
goto Loop              'Endlosschleife

#In1
  deact Bus
  Latch1 = ON
  Daten = Bus
  Latch1 = OFF
  return

#In2
  deact Bus
  Latch2 = ON
  Daten = Bus
  Latch2 = OFF
  return

#In3
  deact Bus
  Latch3 = ON
  Daten = Bus
  Latch3 = OFF
  return

#In4
  deact Bus
  Latch4 = ON
  Daten = Bus
  Latch4 = OFF
  return

end





