'**************************************
'
' C-Control/BASIC       KLIMA.BAS
'
' Aufgabe:
'
' - Messung von Temperatur und Feuchte
' - Senden des Ergebnisses an den PC
' - Grenzwertueberwachung mit LEDs
'
'**************************************
' --- Definitionen --------------------

define Eingang1 AD[2] 
define Eingang2 AD[3]
define TempUnter Port[1]
define TempUeber Port[2]
define HygUnter Port[3]
define HygUeber Port[4]
define Temp word
define Hyg word
define TempMin 18
define TempMax 22
define HygMin 50
define HygMax 70

' --- Programmoperationen -------------

#Loop
  looktab TempTab, Eingang1, Temp
  looktab HygTab, Eingang2, Hyg
  Temp = Temp / 10
  print Temp, "C"
  print Hyg, "%"
  if Temp > TempMax then TempUeber = 1
  if Temp < TempMin then TempUnter = 1
  if Hyg > HygMax then HygUeber = 1
  if Hyg < HygMin then HygUnter = 1
  pause 50              '1 s warten
goto Loop               'Endlosschleife
end

table TempTab ".\TABLES\KTY2.TAB"
table HygTab ".\TABLES\HYG.TAB"


