'**************************************
'
' C-Control/BASIC       KLIMA24.BAS
'
' Aufgabe:
'
' - Messung von Temperatur und Feuchte
' - 24 Messung mit Registrierung
' - Auslesen per Tastendruck
'
'**************************************
' --- Definitionen --------------------

define Eingang1 AD[1]
define Eingang2 AD[2]
define Taste port[9]
define LED1 port[1]
define LED2 port[2]
define Temp word
define Hyg word
define Stunde byte

' --- Programmoperationen -------------

  wait hour = 0    'Mitternacht abwarten
  LED1 = 1         'Messung anzeigen
  Stunde = 0       'Anfang = 0 Uhr
  open# for write  'EEPROM-Datei ffnen
#Loop
  wait hour = Stunde  'Naechste Messung
  looktab TempTab, Eingang1, Temp
  looktab HygTab, Eingang2, Hyg
  Temp = Temp / 10
  print# Temp
  print# Hyg
  Stunde = Stunde +1
  if Stunde < 25 then goto Loop
  close#
  LED1 = 0
#Auslesen
  LED2 = 1           'Auslesen anzeigen
  wait Taste = 0     'Auf Taste warten
  open# for read
  Stunde = 0
#Loop2
  input# Temp
  input# Hyg
  print Stunde, Temp, Hyg
  Stunde = Stunde + 1
  if Stunde < 25 then goto Loop2
  goto Auslesen
end

table TempTab ".\TABLES\KTY2.TAB"
table HygTab ".\TABLES\HYG.TAB"


