'**************************************
'
' C-Control/BASIC       TIMELCD.BAS
'
' Aufgabe:
'
' - Auslesen der Echtzeituhr
' - Anzeige auf einem LCD-Modul
'
'**************************************
' --- Definitionen --------------------

define Datenbus byteport[1]
define RS port[9]
define RW port[10]
define E port[11]
define Daten byte    ' Pufferbyte

define Sekunde byte
define Zahl byte

' --- Programmoperationen -------------

gosub Init
#Loop
  print hour, minute, second
  print day, month, year
  Daten = 0
  gosub Cursor
  Zahl = hour
  gosub Ausgabe
  Daten = 58  '":"
  gosub Zeichen
  Zahl = minute
  gosub Ausgabe
  Daten = 58  '":"
  gosub Zeichen
  Zahl = second
  gosub Ausgabe
  Daten = 64  'Zeile 2
  gosub Cursor
  Zahl = day
  gosub Ausgabe
  Daten = 46  '"."
  gosub Zeichen
  Zahl = month
  gosub Ausgabe
  Daten = 46  '"."
  gosub Zeichen
  Zahl = year
  gosub Ausgabe
  Zahl = second
  #Loop2
  if Sekunde = second then goto Loop2
  Sekunde = second
  goto Loop

#Init
E=0
Daten = &H38    'Initialisierung
gosub Kommando
Daten = &H0E    'Display einschalten
gosub Kommando
Daten = &H01
gosub Kommando
return

#Kommando
RW = 0
RS = 0
Datenbus = Daten
pulse E
return

#Zeichen
RW = 0
RS = 1
Datenbus = Daten
pulse E
return

#Cursor
RW = 0
RS = 0
Datenbus = Daten + &H80
pulse E
return

#Ausgabe     'zweistellige Zahl
Daten = (Zahl / 10) + 48
gosub Zeichen
Daten = (Zahl mod 10) + 48
gosub Zeichen
return
end



